
function p=ejemplo(c1,c2,c3)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%Ejemplo de PCA con caras
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%c1 c2 c3 son las coordenadas a visualizar
%
% ejemplo(1,2,3)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  
  
N=8 %numero de individuos en el sistema de reconocimiento
Nv=6 %numero de eigenvectores del subespacio

%imagenes utilizadas para generar el subespacio PCA
x1=imread('orl-faces/s1/1.pgm');
x2=imread('orl-faces/s2/1.pgm');
x3=imread('orl-faces/s3/1.pgm');
x4=imread('orl-faces/s4/1.pgm');
x5=imread('orl-faces/s5/1.pgm');
x6=imread('orl-faces/s6/1.pgm');
x7=imread('orl-faces/s7/1.pgm');
x8=imread('orl-faces/s8/1.pgm');


for i=1:N
comando=sprintf('x%d=x%d(:);',i,i);
eval(comando);
end

%matriz de datos X
X=[x1 x2 x3 x4 x5 x6 x7 x8]; %cada columna es una cara
X=double(X);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% PCA %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[V,D,Media] = pc_evectors(X,Nv);


for i = 1:N
    Xm(:,i) = X(:,i) - Media; %Quito la media los datos para proyectar 
end;

p=V'*Xm; %proyeccion de las caras generadoras en el subespacio PCA
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Proyeccion del resto de caras de cada individuo en el subespacio PCA
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


for num_cara=1:N
    
for i=1:10
    file_test=sprintf('orl-faces/s%d/%d.pgm',num_cara,i);
    comando=sprintf('t%d=imread(file_test);',i);
    eval(comando);
    comando=sprintf('t%d=t%d(:);',i,i);
    eval(comando);
end

T=[t1 t2 t3 t4 t5 t6 t7 t8 t9 t10]; %cada columna es una cara
T=double(T);

for i = 1:10
    Tm(:,i) = T(:,i) - Media; %Quito la media los datos para proyectar 
end;


proy=V'*Tm;

comando=sprintf('p%d=proy;',num_cara);
eval(comando);

end

%En las variables p1, p2,... p8 se almacenan las proyecciones de las caras




%%%%%% VISUALIZACION DE LAS CLASES

%graficos 3D
figure
plot3(p1(c1,:),p1(c2,:),p1(c3,:),'k*')
hold on
plot3(p2(c1,:),p2(c2,:),p2(c3,:),'b*')
plot3(p3(c1,:),p3(c2,:),p3(c3,:),'g*')
plot3(p4(c1,:),p4(c2,:),p4(c3,:),'r*')
plot3(p5(c1,:),p5(c2,:),p5(c3,:),'y*')
plot3(p6(c1,:),p6(c2,:),p6(c3,:),'bx')
plot3(p7(c1,:),p7(c2,:),p7(c3,:),'ko')
plot3(p8(c1,:),p8(c2,:),p8(c3,:),'mo')
grid
legend('S1','S2','S3','S4','S5','S6','S7','S8')

%graficos 2D
figure
plot(p1(c1,:),p1(c2,:),'k*')
hold on
plot(p2(c1,:),p2(c2,:),'b*')
plot(p3(c1,:),p3(c2,:),'g*')
plot(p4(c1,:),p4(c2,:),'r*')
plot(p5(c1,:),p5(c2,:),'y*')
plot(p6(c1,:),p6(c2,:),'bx')
plot(p7(c1,:),p7(c2,:),'ko')
plot(p8(c1,:),p8(c2,:),'mo')
grid
legend('S1','S2','S3','S4','S5','S6','S7','S8')



%graficos 2D
figure
plot(p1(c1,:),p1(c2,:),'*')
hold on
plot(p2(c1,:),p2(c2,:),'*')
plot(p3(c1,:),p3(c2,:),'*')
plot(p7(c1,:),p7(c2,:),'ro')

grid
legend('Pepe','Juan','Luis','YO')
title('alumno:Xxxx Yyyy Zzzz')